<template>
 <div class="wrapper">
       <div class="header">
          <div>Words Keeper</div>           
          <button @click="$router.push('/Favorite')">FavoriteWords</button>                 
       </div>
      
       <div class="search_content">
       <div class="search">
        <input type="text" class="search-field"  placeholder="Введите слово"
        @input="debounceInput"
        v-model="search"
        >
        <img src="https://image.flaticon.com/icons/svg/49/49116.svg" alt="" class="search-icon">
      </div>
      <p class="search_words">Words:</p>
      
      <div class="words"
      v-for="word in words_data"
      :key="word.id"      >
           <div class="part_of_speech">{{word.partOfSpeech}}</div>
          <div>{{word.definition}}</div>
          <input type="checkbox" name="" id="" class="favorite_words"
          :value="getWordObj(word)"
          @change="check($event)" 
          v-model="word.isFav"         
          >
      </div>
     </div>
   </div>    
</template>

<script>
import debounce from 'debounce'

export default {
  name: "SearchWords",
  props: {
    words_data: {
      type: Array,
      default: () => {
        return []
      }
    }
  },
  data(){
   return { search: ''    
            
                       
  }
  },
  computed: {
    searchHandler() {
      return this.words_data.filter(elm => {
        return elm.body.toLowerCase().includes(this.search)
      })
    }
    
  },
  methods: {
    getWordObj(word) {
     return `{"definition": "${word.definition}", "partOfSpeech": "${word.partOfSpeech}"}`
    },
    debounceInput: debounce(function (e) {
      this.$store.dispatch('GET_WORDS_FROM_API', e.target.value)    
    }, 1000),
    check: function(e) {
      const words = JSON.parse (localStorage.getItem('words'))?? {};
      const checked = e.target.checked;
      const value = e.target.value;
      if (checked) {
         if (!Object.prototype.hasOwnProperty.call(words, this.search))
              {
           words[this.search] = [ value ] 
         }
         else if (Object.prototype.hasOwnProperty.call(words, this.search)){
           words[this.search].push(value)
         }

       } else {
         if (Object.prototype.hasOwnProperty.call(words, this.search)
             && words[this.search].includes(value))  {
           words[this.search] = words[this.search].filter(item => item !== value)
         }

       }
      localStorage.setItem('words', JSON.stringify(words))
		// console.log(e)
    
    }
    
  }
}
</script>


<style scoped>
.wrapper {
    
    margin: 0 auto;
    border: 1px solid black;
    border-top: none;
    background-color: rgb(211, 195, 195);
}
.header {
    display:flex;
    justify-content:space-around;
    border: 1px solid blue;
    border-radius: 3%;
    background-color: darkblue;
}

.header div {
    font-size: 16px;
    font-weight: bold;
    color: cornsilk;
    margin-left: 50px;
    cursor: pointer;
}
.search_content{
  
  display: flex;
  flex-direction: column;
  
}


.search {
    margin: 70px 50px;
    display: inline-flex;
    border: 1px solid black;
    border-radius: 30px;
    padding: 10px;
    background-color: white;
  }
  
  .search-icon {
    width: 20px;
    height: 20px;
    margin-right: 10px;
    order: -1;
  }
  
  .search-field {
    width: 180px;
    border: 0; 
  }
  
  .search-field:focus {
    outline: none;
  }

  .search_content{
      display: block
      
      
  }
  
  .words{
    display: flex;    
    height: 25%;
    width: 25%;    
    margin-left: 40px;
    margin-top: 15px;
    border: 1px solid black;
    border-radius: 30px;
    padding: 10px;
    background-color: white;
  }

  .words:nth-child(odd){
    color:white;
    background-color: black;
  }
  .favorite_words{
    vertical-align: center;
  }

  .part_of_speech{
    font-style: italic;
    padding-right: 10px;
  }
  .search_words{
    font-size: 16px;
    font-style: bold;
    margin-left: 40px;
  }



  
</style>
